﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace HubTile_Crash_14388
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        Storyboard story = new Storyboard();
        public MainPage()
        {
            this.InitializeComponent();
        }

        private void AnimateRotateContent(FrameworkElement displayelement, double from, double to, TimeSpan duration, EasingFunctionBase easing)
        {
            if (PART_Root != null && PART_LayoutRoot != null)
            {
                story = new Storyboard();
                PART_Root.Projection = new PlaneProjection() { CenterOfRotationY = 0.5 };
                PART_LayoutRoot.Visibility = Visibility.Visible;
                DoubleAnimationUsingKeyFrames timeline1 = BuildTimeLine(from, to, duration, easing);
                ObjectAnimationUsingKeyFrames timeline2 = BuildObjectTimeline(Visibility.Collapsed, TimeSpan.FromTicks(duration.Ticks / 2));
                ObjectAnimationUsingKeyFrames timeline3 = BuildObjectTimeline(Visibility.Visible, TimeSpan.FromTicks(duration.Ticks / 2));
                story.Children.Add(timeline1);
                story.Children.Add(timeline2);
                story.Children.Add(timeline3);
                Storyboard.SetTarget(timeline1, PART_Root);
                if (displayelement == PART_LayoutRoot)
                {
                    PART_HubTileContent.RenderTransformOrigin = new Point(0.5, 0.5);
                    PART_HubTileContent.RenderTransform = new CompositeTransform() { ScaleY = -1 };
                    Storyboard.SetTarget(timeline2, PART_LayoutRoot);
                    Storyboard.SetTarget(timeline3, PART_HubTileContent);
                }
                else if (displayelement == PART_HubTileContent)
                {
					PART_LayoutRoot.Visibility = Visibility.Collapsed;
                    Storyboard.SetTarget(timeline2, PART_HubTileContent);
                    Storyboard.SetTarget(timeline3, PART_LayoutRoot);
                }
                Storyboard.SetTargetProperty(timeline1, "(UIElement.Projection).(PlaneProjection.RotationX)");
                Storyboard.SetTargetProperty(timeline2, "(UIElement.Visibility)");
                Storyboard.SetTargetProperty(timeline3, "(UIElement.Visibility)");
                story.Begin();
            }
        }

        private DoubleAnimationUsingKeyFrames BuildTimeLine(double from, double to, TimeSpan duration, EasingFunctionBase easing)
        {
            EasingDoubleKeyFrame keyframe1 = new EasingDoubleKeyFrame();
            keyframe1.Value = from;
            keyframe1.KeyTime = TimeSpan.FromSeconds(0);

            EasingDoubleKeyFrame keyframe2 = new EasingDoubleKeyFrame();
            keyframe2.Value = to;
            keyframe2.KeyTime = duration;
            keyframe2.EasingFunction = easing;

            DoubleAnimationUsingKeyFrames timeline = new DoubleAnimationUsingKeyFrames();
            timeline.KeyFrames.Add(keyframe1);
            timeline.KeyFrames.Add(keyframe2);
            return timeline;
        }

        private ObjectAnimationUsingKeyFrames BuildObjectTimeline(object visibility, TimeSpan duration)
        {
            DiscreteObjectKeyFrame keyframe = new DiscreteObjectKeyFrame();
            keyframe.KeyTime = duration;
            keyframe.Value = visibility;

            ObjectAnimationUsingKeyFrames timeline = new ObjectAnimationUsingKeyFrames();
            timeline.KeyFrames.Add(keyframe);
            return timeline;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            EasingFunctionBase easing = new ElasticEase() { EasingMode = EasingMode.EaseInOut, Oscillations = 0, Springiness = 1 };
            if (PART_HubTileContent != null)
            {
                if (PART_HubTileContent.Visibility == Visibility.Collapsed)
                {
                    AnimateRotateContent(PART_LayoutRoot, 0, 180, TimeSpan.FromSeconds(1), easing);
                }
                else
                {
                    AnimateRotateContent(PART_HubTileContent, 180, 360, TimeSpan.FromSeconds(1), easing);
                }
            }
        }
    }
}
